*************案例分析整理管理层语调
***********对数据进行整理
*********汇总全部文档分词结果
cd E:\Stata大会\文本分析\语调分析/分词
clear
local file: dir . files "*.dta"
append using `file'
bysort keyword: egen sum = sum(frequency)
duplicates drop keyword,force
drop frequency
rename sum frequency
gsort -frequency
wordcloud keyword frequency using 词云.html , replace ///
	size(15 80) range(3840 2160)
shellout 词云.html
cd E:\Stata大会\文本分析\语调分析
save 总词频,replace
****************************
*****************************
***********对情感词库进行匹配
*****************************
*******处理正面词汇
****************************
cd E:\Stata大会\文本分析\语调分析\语调字典
infix strL v 1-10000 using 正面词汇.txt,clear
save 正面词汇,replace
cd E:\Stata大会\文本分析\语调分析
use 总词频,clear
preserve
use E:\Stata大会\文本分析\语调分析\语调字典/正面词汇,clear
levelsof v, local(keyword)
restore
gen count=.
foreach word in `keyword' {
	replace count=1 if keyword =="`word'"
}
keep if count==1
**********正面词汇的词云图
gsort -frequency
wordcloud keyword frequency using 正面词汇.html , replace ///
	size(15 80) range(3840 2160)
shellout 正面词汇.html
save E:\Stata大会\文本分析\语调分析\语调字典/正面词汇,replace
**********统计一份MDA的正面词汇
use E:\Stata大会\文本分析\语调分析\语调字典/正面词汇,clear
levelsof keyword, local(levels)
cd E:\Stata大会\文本分析\语调分析/分词
use 25,clear
foreach var in `levels'{
		gen `var'=frequency if index(keyword,"`var'")
		replace `var'=0 if `var'==.
		replace `var'=sum(`var')
		}
gen 正面词性=0
foreach var in `levels' {
	replace 正面词性=正面词性+`var'
	}
keep in -1
drop keyword flag frequency
save  
	
**********统计每一份MDA的正面词汇
cap mkdir "E:\stata教程\文本分析\语调分析/正面"
use E:\Stata大会\文本分析\语调分析\语调字典/正面词汇,clear
levelsof keyword, local(levels)
cd E:\Stata大会\文本分析\语调分析/分词
local file: dir . files "*.dta"
foreach file in `file'{
	use `file',clear
	foreach var in `levels'{
		gen `var'=frequency if index(keyword,"`var'")
		replace `var'=0 if `var'==.
		replace `var'=sum(`var')
		}
	gen 正面词性=0
	foreach var in `levels' {
		replace 正面词性=正面词性+`var'
		}
	keep in -1
	drop keyword flag frequency
	gen name =ustrregexs(1) if ustrregexm("`file'","(.*?).dta")
	local name = name[1]
	save E:\stata教程\文本分析\语调分析/正面/`name',replace
	}
********对所有正面文档进行合并
cd E:\Stata大会\文本分析\语调分析/正面
clear
local file: dir . files "*.dta"
append using `file'
save E:\Stata大会\文本分析\语调分析/正面词性,replace

*****************************
*******处理负面词汇
****************************
cd E:\Stata大会\文本分析\语调分析\语调字典
infix strL v 1-10000 using 负面词汇.txt,clear
save 负面词汇,replace
cd E:\stata教程\文本分析\语调分析
use 总词频,clear
preserve
use E:\Stata大会\文本分析\语调分析\语调字典/负面词汇,clear
levelsof v, local(keyword)
restore
gen count=.
foreach word in `keyword' {
	replace count=1 if keyword =="`word'"
}
keep if count==1
**********负面词汇的词云图
gsort -frequency
wordcloud keyword frequency using 负面词汇.html , replace ///
	size(15 80) range(3840 2160)
shellout 负面词汇.html
save E:\Stata大会\文本分析\语调分析\语调字典/负面词汇,replace
**********统计每一份MDA的负面词汇
cap mkdir "E:\stata教程\文本分析\语调分析/负面"
use E:\Stata大会\文本分析\语调分析\语调字典/负面词汇,clear
levelsof keyword, local(levels)
cd E:\Stata大会\文本分析\语调分析/分词
local file: dir . files "*.dta"
foreach file in `file'{
	use `file',clear
	foreach var in `levels'{
		gen `var'=frequency if index(keyword,"`var'")
		replace `var'=0 if `var'==.
		replace `var'=sum(`var')
		}
	gen 负面词性=0
	foreach var in `levels' {
		replace 负面词性=负面词性+`var'
		}
	keep in -1
	drop keyword flag frequency
	gen name =ustrregexs(1) if ustrregexm("`file'","(.*?).dta")
	local name = name[1]
	save E:\stata教程\文本分析\语调分析/负面/`name',replace
	}
********对所有负面文档进行合并
cd E:\Stata大会\文本分析\语调分析/负面
clear
local file: dir . files "*.dta"
append using `file'
save E:\Stata大会\文本分析\语调分析/负面词性,replace
**************************
************计算管理层情绪语调
***************************
use E:\Stata大会\文本分析\语调分析/正面词性,clear
sort name
save,replace
use E:\Stata大会\文本分析\语调分析/负面词性,clear
sort name
save,replace
*****正负语调合并
use E:\Stata大会\文本分析\语调分析/正面词性,clear
merge name using E:\Stata大会\文本分析\语调分析/负面词性
gen 语调=(正面词性-负面词性)/(正面词性+负面词性)
order name 正面词性 负面词性 语调
save E:\Stata大会\文本分析\语调分析/MDA情绪词性,replace
*****合并公司
use E:\Stata大会\文本分析\语调分析/MDA情绪词性,clear
destring name,replace
drop _m
sort name
merge name using E:\Stata大会\文本分析\语调分析/stkcd
keep if _m==3
order stkcd year name 正面词性 负面词性 语调
gen 分类=1 if stkcd>10
replace 分类=0 if 分类==.
ttest 语调 ,by(分类)
******************************
*************end**************
******************************

